Package twisted :: Package web :: Module resource :: Class Resource

[frames | no frames]

## Class Resource

Known Subclasses:
  `_HostResource`, `ASISProcessor`, `BlankPage`, `CGIDirectory`, `CGIScript`, `Controller`, `Data`, `DeferredResource`, `DOMController`, `DOMTemplate`, `ErrorPage`, `File`, `FormProcessor`, `Gadget`, `ModelLoader`, `NameVirtualHost`, `Page`, `ParentRedirect`, `PerspectiveWrapper`, `PythonScript`, `Redirect`, `Redirect`, `Resource`, `ResourceGuard`, `ResourceScriptDirectory`, `ResourceScriptWrapper`, `ResourceSubscription`, `ReverseProxyResource`, `RewriterResource`, `SessionWrapper`, `SOAPPublisher`, `Tapestry`, `UsernamePasswordWrapper`, `VHostMonsterResource`, `WidgetResource`, `XMLRPC`

I define a web-accessible resource.

I serve 2 main purposes; one is to provide a standard representation for what HTTP specification calls an 'entity', and the other is to provide an abstract directory structure for URL retrieval.

Method Summary
| ``__init__`(self)` Initialize.
| `delEntity(self, name)`
| ``getChild`(self, path, request)` Retrieve a 'child' resource from me.
| `getChildForRequest(self, request)`
| ``getChildWithDefault`(self, path, request)` Retrieve a static or dynamically generated child resource from me.
| `getDynamicEntity(self, name, request)`
| `getStaticEntity(self, name)`
| `listDynamicEntities(self, request)`
| `listDynamicNames(self)`
| `listEntities(self)`
| `listNames(self)`
| `listStaticEntities(self)`
| `listStaticNames(self)`
| ``putChild`(self, path, child)` Register a static child.
| `reallyPutEntity(self, name, entity)`
| ``render`(self, request)` Render a given resource.
| ``render_HEAD`(self, request)` Default handling of HEAD method.

Class Variable Summary
`tuple` | `__implements__` = `(<class twisted.web.resource.IResource ...`
`class` | `entityType` = `twisted.web.resource.IResource`
`int` | `isLeaf` = 0
`NoneType` | `server` = None

Method Details

### __init__(self)
(Constructor)

Initialize.

### getChild(self, path, request)

Retrieve a 'child' resource from me.

Implement this to create dynamic resource generation -- resources which are always available may be registered with self.putChild().

This will not be called if the class-level variable 'isLeaf' is set in your subclass; instead, the 'postpath' attribute of the request will be left as a list of the remaining path elements.

For example, the URL /foo/bar/baz will normally be:

     | site.resource.getChild('foo').getChild('bar').getChild('baz').

However, if the resource returned by 'bar' has isLeaf set to true, then the getChild call will never be made on it.

  Parameters:
    `path` - a string, describing the child
    `request` - a twisted.web.server.Request specifying meta-information about the request that is being made for this child.

### getChildWithDefault(self, path, request)

Retrieve a static or dynamically generated child resource from me.

First checks if a resource was added manually by putChild, and then call getChild to check for dynamic resources. Only override if you want to affect behaviour of all child lookups, rather than just dynamic ones.

This will check to see if I have a pre-registered child resource of the given name, and call getChild if I do not.

### putChild(self, path, child)

Register a static child.

You almost certainly don't want '/' in your path. If you intended to have the root of a folder, e.g. /foo/, you want path to be ''.

### render(self, request)

Render a given resource. See `IResource`'s render method.

I delegate to methods of self with the form 'render_METHOD' where METHOD is the HTTP that was used to make the request. Examples: render_GET, render_HEAD, render_POST, and so on. Generally you should implement those methods instead of overriding this one.

render_METHOD methods are expected to return a string which will be the rendered page, unless the return value is twisted.web.server.NOT_DONE_YET, in which case it is this class's responsibility to write the results to request.write(data), then call request.finish().

Old code that overrides render() directly is likewise expected to return a string or NOT_DONE_YET.

### render_HEAD(self, request)

Default handling of HEAD method.

I just return self.render_GET(request). When method is HEAD, the framework will handle this correctly.

Class Variable Details

### __implements__

  Type:
    `tuple`
  Value:

        (<class twisted.web.resource.IResource at 0x8450e44>,)

### isLeaf

  Type:
    `int`
  Value:

        0

### server

  Type:
    `NoneType`
  Value:

        None

Generated by Epydoc 2.0 on Sat May 15 20:08:31 2004 | http://epydoc.sf.net